VERSION 5.00
Begin VB.Form frmFolderSync 
   BorderStyle     =   1  'Œ()
   Caption         =   "Folder Syncronyzer"
   ClientHeight    =   1425
   ClientLeft      =   165
   ClientTop       =   1530
   ClientWidth     =   7185
   ClipControls    =   0   'False
   Icon            =   "FolderSync.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1425
   ScaleWidth      =   7185
   StartUpPosition =   3  'Windows ̊l
   Begin VB.CommandButton cmdReffer 
      Caption         =   "..."
      Height          =   255
      Index           =   2
      Left            =   6720
      TabIndex        =   5
      TabStop         =   0   'False
      Top             =   480
      Width           =   375
   End
   Begin VB.CommandButton cmdReffer 
      Caption         =   "..."
      Height          =   255
      Index           =   1
      Left            =   6720
      TabIndex        =   4
      TabStop         =   0   'False
      Top             =   120
      Width           =   375
   End
   Begin VB.TextBox txtFolder 
      Height          =   270
      Index           =   2
      Left            =   120
      OLEDropMode     =   1  '蓮
      TabIndex        =   1
      Top             =   480
      Width           =   6495
   End
   Begin VB.TextBox txtFolder 
      Height          =   270
      Index           =   1
      Left            =   120
      OLEDropMode     =   1  '蓮
      TabIndex        =   0
      Top             =   120
      Width           =   6495
   End
   Begin VB.CommandButton cmdStartCancel 
      Caption         =   "Start"
      Default         =   -1  'True
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   900
      Width           =   1095
   End
   Begin VB.Label lblProgress 
      Height          =   255
      Left            =   1440
      TabIndex        =   3
      Top             =   960
      Width           =   5535
   End
End
Attribute VB_Name = "frmFolderSync"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim mfrmDirSelect(1 To 2) As DialogDirSelect2

Private Sub cmdReffer_Click(Index As Integer)
    mfrmDirSelect(Index).Show vbModal
    If mfrmDirSelect(Index).IsCanceled Then Exit Sub
    
    txtFolder(Index) = mfrmDirSelect(Index).Path
End Sub

Private Sub cmdStartCancel_Click()
    
    On Error GoTo ErrorHandler:
    
    If cmdStartCancel.Caption = "Start" Then
        If Dir$(AddLastBackSlash(txtFolder(1)), vbDirectory + vbHidden) = "" Then
            MsgBox "The First Directory Not Found", vbCritical, "Error"
            Exit Sub
        End If
        
        If Dir$(AddLastBackSlash(txtFolder(2)), vbDirectory + vbHidden) = "" Then
            MsgBox "The Second Directory Not Found", vbCritical, "Error"
            Exit Sub
        End If
            
        IsCanceled = False
        cmdStartCancel.Caption = "Cancel"
    
        UpdateFilesInSubFolders txtFolder(1), txtFolder(2), Me
        UpdateFilesInSubFolders txtFolder(2), txtFolder(1), Me
        
        cmdStartCancel.Caption = "Start"
        If Not IsCanceled Then
            lblProgress.Caption = "** Operation Completed **"
        Else
            lblProgress.Caption = "** Operation Canceled **"
        End If
        
        ChDir App.Path
        Beep
    Else
        IsCanceled = True
    End If
    
    Exit Sub
    
ErrorHandler:
    MsgBox Err.Description, vbCritical, "Error"
End Sub

Public Sub FileOp(ByVal strMessage As String)
    lblProgress.Caption = Left(strMessage, 6) _
            & DigestPath(Right(strMessage, Len(strMessage) - 6), 44)
    DoEvents
End Sub

Private Sub Form_Load()
    IsCanceled = True
    
    txtFolder(1).Text = GetPhrase(Command$)
    txtFolder(2).Text = GetPhrase
    
    If txtFolder(1).Text <> "" And txtFolder(2).Text <> "" Then
        cmdStartCancel.Enabled = True
    Else
        cmdStartCancel.Enabled = False
    End If

    Set mfrmDirSelect(1) = New DialogDirSelect2
    Set mfrmDirSelect(2) = New DialogDirSelect2
End Sub

Private Sub Form_QueryUnload(CancelUnload As Integer, UnloadMode As Integer)
    
    If cmdStartCancel.Caption = "Cancel" Then
        CancelUnload = True
        MsgBox "Operation Excecuting.  Hit Cancel First", vbInformation
    End If
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Unload mfrmDirSelect(1)
    Unload mfrmDirSelect(2)
End Sub

Private Sub txtFolder_Change(Index As Integer)
    If txtFolder(1) <> "" And txtFolder(2) <> "" Then _
        cmdStartCancel.Enabled = True
End Sub

Private Sub txtFolder_GotFocus(Index As Integer)
    txtFolder(Index).SelStart = Len(txtFolder(Index).Text)
End Sub

Private Sub txtFolder_OLEDragDrop(Index As Integer, Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    txtFolder(Index) = Data.Files(1)
End Sub

Private Sub txtFolder_OLEDragOver(Index As Integer, Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    
    'Is File or Folder?
    If Not Data.GetFormat(vbCFFiles) Then
        Effect = vbDropEffectNone
        Exit Sub
    End If
        
    'Single Selection?
    If Data.Files.Count <> 1 Then
        Effect = vbDropEffectNone
        Exit Sub
    End If
    
    'Is Folder?
    If (GetAttr(Data.Files(1)) And vbDirectory) <> vbDirectory Then
        Effect = vbDropEffectNone
        Exit Sub
    End If
   
End Sub

Private Function DigestPath(ByVal strFullPath As String, _
                            ByVal lngMaxLen As Long) As String
    
    Dim strHead As String, strTail As String
    Dim lngHeadMaxLen As Long, lngTailMaxLen As Long
    Dim lngPtr As Long, lngLenHead As Long
    
    On Error GoTo ErrorHandler:
    
    If Len(strFullPath) <= lngMaxLen Then
        DigestPath = strFullPath
    
    Else
        lngHeadMaxLen = lngMaxLen \ 4
        lngTailMaxLen = lngMaxLen \ 2
    
'       *** Generate Head Part ***
        strHead = Left(strFullPath, lngHeadMaxLen)
        lngPtr = Len(strHead)
        Do Until Mid(strHead, lngPtr, 1) = "\"
            lngPtr = lngPtr - 1
        Loop
        If lngPtr > 3 Then strHead = Left(strHead, lngPtr)
        
'       *** Generate Tail Part ***
        strTail = Right(strFullPath, lngTailMaxLen)
        lngPtr = InStr(strTail, "\")
        
        If lngPtr > 1 Then
            strTail = Right(strTail, Len(strTail) - lngPtr + 1)
        
        ElseIf lngPtr = 0 Then
            lngPtr = Len(strFullPath)
            Do Until Mid(strFullPath, lngPtr, 1) = "\"
                lngPtr = lngPtr - 1
            Loop
            strTail = Right(strFullPath, Len(strFullPath) - lngPtr)
            
            lngLenHead = lngHeadMaxLen - Len(strTail) + lngTailMaxLen
            If lngLenHead <= 0 Then
                strHead = ""
            Else
                strHead = Left(strHead, lngLenHead)
            End If
        End If
        
        DigestPath = strHead & "..." & strTail
        Debug.Print DigestPath
    End If
    
    Exit Function

ErrorHandler:
    DigestPath = ""
    
End Function

Private Function AddLastBackSlash _
                    (ByVal strPath As String) As String
    If Right$(strPath, 1) <> "\" Then
        AddLastBackSlash = strPath & "\"
    Else
        AddLastBackSlash = strPath
    End If
End Function

Private Function GetPhrase(Optional ByVal strData = "") As String
    Const SEP_SPACE As String = " "
    Const SEP_DQ As String = """"
    
    Static strBuffer As String
    Dim lngPtr As Long
    
    If strData <> "" Then strBuffer = Trim$(strData)
    
    If strBuffer <> "" Then
        If Left$(strBuffer, 1) = SEP_DQ Then
            strBuffer = Trim$(Right$(strBuffer, Len(strBuffer) - 1))
            lngPtr = InStr(strBuffer, SEP_DQ)
        Else
            lngPtr = InStr(strBuffer, SEP_SPACE)
        End If
                
        If lngPtr <> 0 Then
            GetPhrase = Left$(strBuffer, lngPtr - 1)
            strBuffer = Trim$(Right$(strBuffer, Len(strBuffer) - lngPtr))
        Else
            GetPhrase = strBuffer
            strBuffer = ""
        End If
    Else
        GetPhrase = ""
    End If
    
    Debug.Print strBuffer
    
End Function


